Loading...
Searching...
No Matches
gx_preset::GxSettings Class Reference

`#include <gx_preset.h>`

Inheritance diagram for gx_preset::GxSettings:

## Public Member Functions

| GxSettings (gx_system::CmdlineOptions &opt, gx_jack::GxJack &jack, gx_engine::ConvolverAdapter &cvr, gx_engine::MidiStandardControllers &mstdctr, gx_engine::MidiControllerList &mctrl, gx_engine::ModuleSequencer &seq)
| ~GxSettings ()
gx_engine::ParamMap & | get_param () const
gx_system::CmdlineOptions & | get_options () const
void | loadstate ()
bool | get_auto_save_state ()
void | disable_autosave (bool v)
void | disable_save_on_exit (bool v)
void | auto_save_state ()
void | plugin_preset_list_load (const PluginDef *pdef, UnitPresetList &presetnames)
void | plugin_preset_list_sync_set (const PluginDef *pdef, bool factory, const Glib::ustring &name)
void | plugin_preset_list_set (const PluginDef *pdef, bool factory, const Glib::ustring &name)
void | plugin_preset_list_save (const PluginDef *pdef, const Glib::ustring &name)
void | plugin_preset_list_remove (const PluginDef *pdef, const Glib::ustring &name)
void | create_default_scratch_preset ()
std::vector< std::string > & | get_rack_unit_order (bool stereo)
sigc::signal< void, bool > & | signal_rack_unit_order_changed ()
bool | remove_rack_unit (const std::string &unit, bool stereo)
void | insert_rack_unit (const std::string &unit, const std::string &before, bool stereo)
Glib::RefPtr< Gio::File > | uri_to_name_filename (const Glib::ustring &uri, Glib::ustring &name, std::string &filename)
gx_system::PresetFile * | bank_insert_uri (const Glib::ustring &uri, bool move, int position=0)
gx_system::PresetFile * | bank_insert_content (const Glib::ustring &uri, const std::string content, int position=0)
gx_system::PresetFile * | bank_insert_new (const Glib::ustring &name)
bool | rename_bank (const Glib::ustring &oldname, Glib::ustring &newname)
Public Member Functions inherited from gx_system::GxSettingsBase
sigc::signal< void > & | signal_selection_changed ()
sigc::signal< void > & | signal_presetlist_changed ()
| GxSettingsBase (gx_engine::EngineControl &seq_)
| ~GxSettingsBase ()
const Glib::ustring & | get_current_bank ()
PresetFile * | get_current_bank_file ()
const Glib::ustring & | get_current_name ()
void | set_statefilename (const std::string &fn)
void | save_to_state (bool preserve_preset=false)
void | set_source_to_state ()
void | erase_preset (const Glib::ustring &name)
bool | setting_is_preset ()
bool | convert_preset (PresetFile &pf)
void | reorder_preset (PresetFile &pf, const std::vector< Glib::ustring > &neworder)
void | erase_preset (PresetFile &pf, const Glib::ustring &name)
void | save (PresetFile &pf, const Glib::ustring &name)
void | append (PresetFile &pf, const Glib::ustring &src, PresetFile &pftgt, const Glib::ustring &name)
void | insert_before (PresetFile &pf, const Glib::ustring &src, PresetFile &pftgt, const Glib::ustring &pos, const Glib::ustring &name)
void | insert_after (PresetFile &pf, const Glib::ustring &src, PresetFile &pftgt, const Glib::ustring &pos, const Glib::ustring &name)
void | load_preset (PresetFile *pf, const Glib::ustring &name)
bool | rename_bank (const Glib::ustring &oldname, const Glib::ustring &newname, const std::string &newfile)
bool | remove_bank (const Glib::ustring &bank)
bool | rename_preset (PresetFile &pf, const Glib::ustring &oldname, const Glib::ustring &newname)

## Static Public Member Functions

static void | check_settings_dir (gx_system::CmdlineOptions &opt, bool *need_new_preset)

## Private Member Functions

void | add_plugin_preset_list (PluginPresetList &l, UnitPresetList &presetnames)
void | exit_handler (bool otherthread)
void | jack_client_changed ()
string | make_state_filename ()
string | make_default_state_filename ()
void | preset_sync_start ()
void * | sync_run ()
void | preset_sync_set ()
void | on_get_sequencer_pos ()

## Static Private Member Functions

static bool | check_create_config_dir (const Glib::ustring &dir)
static void * | preset_sync_run (void *p)

## Private Attributes

gx_engine::ParamMap & | param
gx_preset::PresetIO | preset_io
gx_preset::StateIO | state_io
bool | state_loaded
bool | no_autosave
bool | no_save_on_exit
gx_jack::GxJack & | jack
gx_engine::MidiControllerList & | mctrl
gx_system::CmdlineOptions & | options
gx_engine::StringParameter & | preset_parameter
gx_engine::StringParameter & | bank_parameter
UnitRacks | rack_units
Glib::ustring | sync_name
Glib::Dispatcher | set_preset
Glib::Dispatcher | get_sequencer_p
volatile int | sequencer_max
volatile int | sequencer_pos

## Static Private Attributes

static GxSettings * | instance

## Friends

class | ::PosixSignals

## Additional Inherited Members

Protected Member Functions inherited from gx_system::GxSettingsBase
bool | loadsetting (PresetFile *p, const Glib::ustring &name)
void | loadstate ()
void | set_io (AbstractStateIO *st, AbstractPresetIO *pr)
Protected Attributes inherited from gx_system::GxSettingsBase
AbstractStateIO * | state_io
AbstractPresetIO * | preset_io
StateFile | statefile
PresetBanks | banks
Glib::ustring | current_bank
Glib::ustring | current_name
gx_engine::EngineControl & | seq
sigc::signal< void > | selection_changed
sigc::signal< void > | presetlist_changed

## Detailed Description

Definition at line 140 of file gx_preset.h.

## Constructor & Destructor Documentation

## GxSettings()

gx_preset::GxSettings::GxSettings | ( | gx_system::CmdlineOptions & | opt,
|  | gx_jack::GxJack & | jack,
|  | gx_engine::ConvolverAdapter & | cvr,
|  | gx_engine::MidiStandardControllers & | mstdctr,
|  | gx_engine::MidiControllerList & | mctrl,
|  | gx_engine::ModuleSequencer & | seq )

## ~GxSettings()

gx_preset::GxSettings::~GxSettings | ( |  | ) |

## Member Function Documentation

## add_plugin_preset_list()

void gx_preset::GxSettings::add_plugin_preset_list | ( | PluginPresetList & | l,
|  | UnitPresetList & | presetnames )

private

## auto_save_state()

void gx_preset::GxSettings::auto_save_state | ( |  | ) |

## bank_insert_content()

gx_system::PresetFile * gx_preset::GxSettings::bank_insert_content | ( | const Glib::ustring & | uri,
|  | const std::string | content,
|  | int | position = 0 )

## bank_insert_new()

gx_system::PresetFile * gx_preset::GxSettings::bank_insert_new | ( | const Glib::ustring & | name | ) |

## bank_insert_uri()

gx_system::PresetFile * gx_preset::GxSettings::bank_insert_uri | ( | const Glib::ustring & | uri,
|  | bool | move,
|  | int | position = 0 )

## check_create_config_dir()

bool gx_preset::GxSettings::check_create_config_dir | ( | const Glib::ustring & | dir | ) |

static private

## check_settings_dir()

void gx_preset::GxSettings::check_settings_dir | ( | gx_system::CmdlineOptions & | opt,
|  | bool * | need_new_preset )

static

## create_default_scratch_preset()

void gx_preset::GxSettings::create_default_scratch_preset | ( |  | ) |

## disable_autosave()

void gx_preset::GxSettings::disable_autosave | ( | bool | v | ) |

inline

Definition at line 186 of file gx_preset.h.

## disable_save_on_exit()

void gx_preset::GxSettings::disable_save_on_exit | ( | bool | v | ) |

inline

Definition at line 187 of file gx_preset.h.

## exit_handler()

void gx_preset::GxSettings::exit_handler | ( | bool | otherthread | ) |

private

## get_auto_save_state()

bool gx_preset::GxSettings::get_auto_save_state | ( |  | ) |

inline

Definition at line 185 of file gx_preset.h.

## get_options()

gx_system::CmdlineOptions & gx_preset::GxSettings::get_options | ( |  | ) | const

inline

Definition at line 182 of file gx_preset.h.

## get_param()

gx_engine::ParamMap & gx_preset::GxSettings::get_param | ( |  | ) | const

inline

Definition at line 181 of file gx_preset.h.

## get_rack_unit_order()

std::vector< std::string > & gx_preset::GxSettings::get_rack_unit_order | ( | bool | stereo | ) |

inline

Definition at line 195 of file gx_preset.h.

## insert_rack_unit()

void gx_preset::GxSettings::insert_rack_unit | ( | const std::string & | unit,
|  | const std::string & | before,
|  | bool | stereo )

## jack_client_changed()

void gx_preset::GxSettings::jack_client_changed | ( |  | ) |

private

## loadstate()

void gx_preset::GxSettings::loadstate | ( |  | ) |

## make_default_state_filename()

string gx_preset::GxSettings::make_default_state_filename | ( |  | ) |

private

## make_state_filename()

string gx_preset::GxSettings::make_state_filename | ( |  | ) |

private

## on_get_sequencer_pos()

void gx_preset::GxSettings::on_get_sequencer_pos | ( |  | ) |

private

## plugin_preset_list_load()

void gx_preset::GxSettings::plugin_preset_list_load | ( | const PluginDef * | pdef,
|  | UnitPresetList & | presetnames )

## plugin_preset_list_remove()

void gx_preset::GxSettings::plugin_preset_list_remove | ( | const PluginDef * | pdef,
|  | const Glib::ustring & | name )

## plugin_preset_list_save()

void gx_preset::GxSettings::plugin_preset_list_save | ( | const PluginDef * | pdef,
|  | const Glib::ustring & | name )

## plugin_preset_list_set()

void gx_preset::GxSettings::plugin_preset_list_set | ( | const PluginDef * | pdef,
|  | bool | factory,
|  | const Glib::ustring & | name )

## plugin_preset_list_sync_set()

void gx_preset::GxSettings::plugin_preset_list_sync_set | ( | const PluginDef * | pdef,
|  | bool | factory,
|  | const Glib::ustring & | name )

## preset_sync_run()

void * gx_preset::GxSettings::preset_sync_run | ( | void * | p | ) |

static private

## preset_sync_set()

void gx_preset::GxSettings::preset_sync_set | ( |  | ) |

private

## preset_sync_start()

void gx_preset::GxSettings::preset_sync_start | ( |  | ) |

private

## remove_rack_unit()

bool gx_preset::GxSettings::remove_rack_unit | ( | const std::string & | unit,
|  | bool | stereo )

## rename_bank()

bool gx_preset::GxSettings::rename_bank | ( | const Glib::ustring & | oldname,
|  | Glib::ustring & | newname )

## signal_rack_unit_order_changed()

sigc::signal< void, bool > & gx_preset::GxSettings::signal_rack_unit_order_changed | ( |  | ) |

inline

Definition at line 196 of file gx_preset.h.

## sync_run()

void * gx_preset::GxSettings::sync_run | ( |  | ) |

private

## uri_to_name_filename()

Glib::RefPtr< Gio::File > gx_preset::GxSettings::uri_to_name_filename | ( | const Glib::ustring & | uri,
|  | Glib::ustring & | name,
|  | std::string & | filename )

## Friends And Related Symbol Documentation

## ::PosixSignals

friend class ::PosixSignals

friend

Definition at line 161 of file gx_preset.h.

## Member Data Documentation

## bank_parameter

gx_engine::StringParameter& gx_preset::GxSettings::bank_parameter

private

Definition at line 152 of file gx_preset.h.

## get_sequencer_p

Glib::Dispatcher gx_preset::GxSettings::get_sequencer_p

private

Definition at line 172 of file gx_preset.h.

## instance

GxSettings* gx_preset::GxSettings::instance

static private

Definition at line 160 of file gx_preset.h.

## jack

gx_jack::GxJack& gx_preset::GxSettings::jack

private

Definition at line 148 of file gx_preset.h.

Referenced by GxSettings().

## mctrl

gx_engine::MidiControllerList& gx_preset::GxSettings::mctrl

private

Definition at line 149 of file gx_preset.h.

Referenced by GxSettings().

## no_autosave

bool gx_preset::GxSettings::no_autosave

private

Definition at line 146 of file gx_preset.h.

Referenced by disable_autosave(), and get_auto_save_state().

## no_save_on_exit

bool gx_preset::GxSettings::no_save_on_exit

private

Definition at line 147 of file gx_preset.h.

Referenced by disable_save_on_exit().

## options

gx_system::CmdlineOptions& gx_preset::GxSettings::options

private

Definition at line 150 of file gx_preset.h.

Referenced by get_options().

## param

gx_engine::ParamMap& gx_preset::GxSettings::param

private

Definition at line 142 of file gx_preset.h.

Referenced by get_param().

## preset_io

gx_preset::PresetIO gx_preset::GxSettings::preset_io

private

Definition at line 143 of file gx_preset.h.

## preset_parameter

gx_engine::StringParameter& gx_preset::GxSettings::preset_parameter

private

Definition at line 151 of file gx_preset.h.

## rack_units

UnitRacks gx_preset::GxSettings::rack_units

private

Definition at line 153 of file gx_preset.h.

Referenced by get_rack_unit_order(), and signal_rack_unit_order_changed().

## sequencer_max

volatile int gx_preset::GxSettings::sequencer_max

private

Definition at line 173 of file gx_preset.h.

## sequencer_pos

volatile int gx_preset::GxSettings::sequencer_pos

private

Definition at line 174 of file gx_preset.h.

## set_preset

Glib::Dispatcher gx_preset::GxSettings::set_preset

private

Definition at line 171 of file gx_preset.h.

## state_io

gx_preset::StateIO gx_preset::GxSettings::state_io

private

Definition at line 144 of file gx_preset.h.

## state_loaded

bool gx_preset::GxSettings::state_loaded

private

Definition at line 145 of file gx_preset.h.

## sync_name

Glib::ustring gx_preset::GxSettings::sync_name

private

Definition at line 165 of file gx_preset.h.

The documentation for this class was generated from the following file:

- src/headers/gx_preset.h